#!/bin/bash
echo -e "\e[1;5m\n== SciViews Box 2019 v2.0.0 installation…\e[0m"

# We try to avoid asking for password by using the default one with sudo
# If it fails, ask anyway!
#echo 'sv\n' | sudo -S ls > /dev/null 2> /dev/null
# Ask password with a GUI (because Windows or Mac users are surprised with the
# default terminal interface where typed characters are not echoed with stars!)
mkdir -p /home/sv/.config/svbox
echo '#!/bin/bash
yad --on-top --title "sudo password prompt" \
  --text="<b>Enter your password</b>\n\nThe installer needs it for administrative tasks.\n\n" \
  --window-icon=dialog-password --image=dialog-password --borders=6 --center --fixed \
  --entry --hide-text 2> /dev/null
' > /home/sv/.config/svbox/askpass
chmod +x /home/sv/.config/svbox/askpass
export SUDO_ASKPASS="/home/sv/.config/svbox/askpass"
sudo -A ls > /dev/null

# Warn the user
notify-send "Svbox2019-2 installation" "Please wait: configuration in course... You can continue your work in the meantime."

# Make sure there is no unattended update in course
pkill -f update-notifier
pkill -f update-manager
sudo systemctl stop apt-daily.service apt-daily.timer apt-daily-upgrade.service apt-daily-upgrade.timer
sudo systemctl kill --kill-who=all apt-daily.service apt-daily-upgrade.service
if ! (systemctl list-units --all apt-daily.service | grep -q failed); then
  while ! (systemctl list-units --all apt-daily.service | grep -q dead); do sleep 1; done;
fi
if ! (systemctl list-units --all apt-daily-upgrade.service | grep -q failed); then
  while ! (systemctl list-units --all apt-daily-upgrade.service | grep -q dead); do sleep 1; done;
fi
sudo rm /var/lib/apt/lists/lock
sudo rm /var/cache/apt/archives/lock
sudo rm /var/lib/dpkg/lock
sudo dpkg --configure -a
# Disable unattended upgrade
sudo sed -i 's/APT::Periodic::Update-Package-Lists "1"/APT::Periodic::Update-Package-Lists "0"/' /etc/apt/apt.conf.d/20auto-upgrades
sudo sed -i 's/APT::Periodic::Unattended-Upgrade "1"/APT::Periodic::Unattended-Upgrade "0"/' /etc/apt/apt.conf.d/20auto-upgrades

# Install an update for mongolite
R -q -e 'remotes::install_github("jeroen/mongolite@32147b3")'

# Indicate install is done
echo "Svbox2019-2 installed..."
notify-send "Svbox2019-2 installation" "Update installed."
